﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals
	'the vuetify instance	
	Public vuetify As VuetifyApp
	'this route page
	Public page As VueComponent
	'the path to this page
	Public path As String
	'the name of the page, should be unique
	Public name As String = "uploadfiles"
	'banano transpiler
	Private banano As BANano			'ignore

	Private txtTargetUpload As VFileInput
	Private txtUsualUpload As VFileInput
	Private VCol1 As VCol
	Private VCol2 As VCol
	Private VContainer1 As VContainer
	Private VRow1 As VRow
	Private VRow2 As VRow
	Private lblFullPath As VLabel
	Private txtToAssetsRename As VFileInput
	Private txtToFilesRename As VFileInput
	Private VCol3 As VCol
	Private VCol4 As VCol
	Private VCol5 As VCol
	Private VRow3 As VRow
	Private VRow4 As VRow
	Private VRow5 As VRow
	Private txtFileRename As VFileInput
End Sub

'initializes the page and builds the html structure
Sub Initialize(v As VuetifyApp)						'ignoreDeadCode
	'establish a reference to the app
	vuetify = v
	'initialize the page using unique name
	page.Initialize(Me, name)
	'link the vuetify instance
	page.vuetify = vuetify
	'set the page title
	page.Title = "BVAD3 - Upload Files"
	'make this the start page
	page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "uploadfileslayout")
	
	'add this route component to the app
	vuetify.AddRoute(page)
End Sub

Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
	'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
	'update the page title
	vuetify.SetBrowserTitle(boTo)
End Sub

Private Sub btnClickMe_Click (e As BANanoEvent)
	vuetify.ShowSwalSuccess("You clicked me!")
End Sub

'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
'Sub created		'IgnoreDeadCode
'	Log("created")
'End Sub

'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub mounted		'ignoreDeadCode
	vuetify.Loading(False)
End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub txtUsualUpload_Change (fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	txtUsualUpload.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = banano.Await(BANanoShared.UploadFileOptionsWait(fileObj, "../assets", "n"))
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	'get the file name
	Dim fn As String = fileDet.FileName
	Select Case sstatus
	Case "error"
		'hide the uploader
		txtUsualUpload.UpdateLoading(page, False)
		vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
	Case "success"
		vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'IMPORTANT
	fp = fp.Replace("../assets", "./assets")
	lblFullPath.UpdateCaption(fp)
	'update state of some element like an image
	'vimage.SetImage(page, fp)
	'hide the uploading status
	txtUsualUpload.UpdateLoading(page, False)
End Sub

Private Sub txtTargetUpload_Change (fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	txtTargetUpload.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = banano.Await(BANanoShared.UploadFileOptionsWait(fileObj, "../files", "n"))
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	'get the file name
	Dim fn As String = fileDet.FileName
	Select Case sstatus
	Case "error"
		'hide the uploader
		txtTargetUpload.UpdateLoading(page, False)
		vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
	Case "success"
		vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'IMPORTANT
	fp = fp.Replace("../files", "./files")
	lblFullPath.UpdateCaption(fp)
	'update state of some element like an image
	'vimage.SetImage(page, fp)
	'hide the uploading status
	txtTargetUpload.UpdateLoading(page, False)
End Sub

Private Sub txtToFilesRename_Change (fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	txtToFilesRename.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = banano.Await(BANanoShared.UploadFileOptionsWait(fileObj, "../files", "y"))
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	'get the file name
	Dim fn As String = fileDet.FileName
	Select Case sstatus
		Case "error"
			'hide the uploader
			txtToFilesRename.UpdateLoading(page, False)
			vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
		Case "success"
			vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'IMPORTANT
	fp = fp.Replace("../files", "./files")
	lblFullPath.UpdateCaption(fp)
	'update state of some element like an image
	'vimage.SetImage(page, fp)
	'hide the uploading status
	txtToFilesRename.UpdateLoading(page, False)
End Sub

Private Sub txtToAssetsRename_Change (fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	txtToAssetsRename.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = banano.Await(BANanoShared.UploadFileOptionsWait(fileObj, "../assets", "y"))
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	'get the file name
	Dim fn As String = fileDet.FileName
	Select Case sstatus
		Case "error"
			'hide the uploader
			txtToAssetsRename.UpdateLoading(page, False)
			vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
		Case "success"
			vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'IMPORTANT
	fp = fp.Replace("../assets", "./assets")
	lblFullPath.UpdateCaption(fp)
	'update state of some element like an image
	'vimage.SetImage(page, fp)
	'hide the uploading status
	txtToAssetsRename.UpdateLoading(page, False)
End Sub

Private Sub txtFileRename_Change (fileObj As Map)
	page.refs = vuetify.GetRefs
	'has the file been specified
	If banano.IsNull(fileObj) Or banano.IsUndefined(fileObj) Then Return
	'show the loading indicator
	txtToAssetsRename.UpdateLoading(page, True)
	'get file details
	Dim fileDet As FileObject
	fileDet = BANanoShared.GetFileDetails(fileObj)
	'you can check the size here
	Dim fs As Long = fileDet.FileSize
	'get the file name and rename it
	Dim FileName As String = "batch-" & BANanoShared.DateTimeNowBackUp & "-" & fileDet.FileName
	
	If fs >= 5000 Then
	End If
	'start uploading the file to assets folder
	fileDet = banano.Await(BANanoShared.UploadFileRenameToWait(fileObj, "../assets", FileName))
	'get the status of the upload
	Dim sstatus As String = fileDet.Status
	'get the file name
	Dim fn As String = fileDet.FileName
	Select Case sstatus
	Case "error"
		'hide the uploader
		txtToAssetsRename.UpdateLoading(page, False)
		vuetify.ShowSnackBarError($"The file '${fn}' was not uploaded successfully!"$)
	Case "success"
		vuetify.ShowSnackBarSuccess($"The file '${fn}' was uploaded successfully!"$)
	End Select
	'get the upload full path
	Dim fp As String = fileDet.FullPath
	'IMPORTANT
	fp = fp.Replace("../assets", "./assets")
	lblFullPath.UpdateCaption(fp)
	'update state of some element like an image
	'vimage.SetImage(page, fp)
	'hide the uploading status
	txtToAssetsRename.UpdateLoading(page, False)
End Sub